/*
 * src/callback.h
 *
 * Copyright (C) 2019 Ilja Kartašov <ik@lowenware.com>
 *
 * Project homepage: https://lowenware.com/aisl/
 *
 */

#ifndef AISL_CALLBACK_H_43D3FC6B_22E5_481C_8EB2_00BF8C3D52CA
#define AISL_CALLBACK_H_43D3FC6B_22E5_481C_8EB2_00BF8C3D52CA

#include <aisl/types.h>


struct callback
{
  void            * source;
  aisl_callback_t   f_ptr;
  aisl_event_t      event;
};

typedef struct callback * callback_t;


static listener_t
listener_new( void * source, aisl_event_t e_id, aisl_callback_t cb)
{
  listener_t self = malloc(sizeof(struct listener));
  if (self)
  {
    self->source = source;
    self->e_id   = e_id;
    self->cb     = cb;
  }

  return self;
}



#endif /* !AISL_CALLBACK_H */
