/*
 * src/instance.h
 *
 * Copyright (C) 2019 Ilja Kartašov <ik@lowenware.com>
 *
 * Project homepage: https://lowenware.com/aisl/
 *
 */

#ifndef AISL_INSTANCE_H_814CF474_A646_45B7_B6B2_3F4C7BEFA484
#define AISL_INSTANCE_H_814CF474_A646_45B7_B6B2_3F4C7BEFA484

#ifndef AISL_WITHOUT_SSL
#include <openssl/ssl.h>
#endif

#include <aisl/instance.h>


#ifndef AISL_WITHOUT_SSL
/**
 * @brief Gets SSL context for appropriate server name.
 * @param instance a pointer to #aisl_t instance.
 * @param server_name a null-terminated string with server name or NULL.
 * @return a pointer to SSL context
 */
SSL_CTX *
aisl_get_ssl_ctx( aisl_t instance, const char * server_name );
#endif


/**
 * @brief Sets error message for AISL instace.
 * @param instance a pointer to #aisl_t instance.
 * @param err_msge a null-terminated string with error message.
 */
void
aisl_set_error( aisl_t instance, const char * err_msg );

#endif /* !INSTANCE_H */
