/*
 * src/ssl.h
 *
 * Copyright (C) 2019 Ilja Kartašov <ik@lowenware.com>
 *
 * Project homepage: https://lowenware.com/aisl/
 *
 */

#ifndef AISL_SSL_H_6F82B0BA_7C59_45BA_AF3B_C82A67C8585E
#define AISL_SSL_H_6F82B0BA_7C59_45BA_AF3B_C82A67C8585E

#include <aisl/types.h>
#include <openssl/ssl.h>


struct ssl
{
  char    * key_file;
  char    * crt_file;
  char    * domain;
  SSL_CTX * ctx;
};

typedef struct ssl * ssl_t;


ssl_t
ssl_new( const char * key_file, const char * crt_file, const char * domain, SSL_CTX * ctx );


void
ssl_free( ssl_t self );


#endif /* !AISL_SSL_H */
